<template>
  <div class="savings container">
    <h1 style="text-align: center;">Savings Dapp</h1>
    <table id="savings-dapp">
      <tr>
        <td>
          Deposit:
        </td>
        <td>
          <input v-model="depositAmount" placeholder="0" />
          <select v-model="selectedDeposit">
            <option>ether</option>
            <option>wei</option>
          </select>
        </td>
        <td>
          <button v-on:click="clickDeposit" class="button">Deposit</button>
        </td>
      </tr>
      <tr>
        <td>
          Withdraw:
        </td>
        <td>
          <input v-model="withdrawAmount" placeholder="0" />
          <select v-model="selectedWithdraw">
            <option>ether</option>
            <option>wei</option>
          </select>
        </td>
        <td>
          <button v-on:click="clickWithdraw" class="button">Withdraw</button>
        </td>
      </tr>
      <tr>
        <td colspan="3">
          <button v-on:click="clickGetBalance" class="button">Get Balance</button><br />
        </td>
      </tr>
      <tr>
        <td colspan="3">
          <span>Saldo de contrato {{ contractBalance }} ether(s)</span>
        </td>
      </tr>
      <tr>
        <td colspan="3">
          <span>Saldo de contrato {{ contractBalanceWei }} wei(s)</span>
        </td>
      </tr>
    </table>
  </div>
</template>
<script>
export default {
  name: 'savings',
  data () {
    return {
      depositAmount: null,
      withdrawAmount: null,
      pending: false,
      contractBalance: null,
      contractBalanceWei: null,
      selectedDeposit: 'ether',
      selectedWithdraw: 'ether'
    }
  },
  methods: {
    clickGetBalance (event) {
      console.log('Getting balance ', event.target.innerHTML, this.amount)
      this.contractBalance = null
      this.pending = true
      this.$store.state.contractInstance().checkContractBalance(
        {
          gas: 300000,
          value: this.$store.state.web3
            .web3Instance()
            .toWei(this.amount, 'ether'),
          from: this.$store.state.web3.coinbase
        },
        (err, result) => {
          if (err) {
            console.log(err)
            this.pending = false
          } else {
            this.contractBalance = (result / 1e18).toFixed(18)
            this.contractBalanceWei = result
          }
        }
      )
    },
    clickDeposit (event) {
      console.log('Value to deposit ', this.depositAmount)
      this.contractBalance = null
      this.pending = true
      this.$store.state.contractInstance().deposit(
        {
          gas: 300000,
          value: this.selectedDeposit === 'wei' ? this.depositAmount : this.$store.state.web3.web3Instance().toWei(this.depositAmount, 'ether'),
          from: this.$store.state.web3.coinbase
        },
        (err, result) => {
          if (err) {
            console.log(err)
            this.pending = false
          } else {
            console.log('SIN ERRORES')
          }
        }
      )
    },
    clickWithdraw (event) {
      console.log('Value to Withdraw', this.withdrawAmount, this.selectedWithdraw)
      console.log('Value to Withdraw in ether', this.selectedWithdraw === 'ether' ? this.withdrawAmount : (this.withdrawAmount / 1e18))
      console.log('Value to Withdraw in wei', this.selectedWithdraw === 'wei' ? this.withdrawAmount : this.$store.state.web3.web3Instance().toWei(this.withdrawAmount, 'ether'))
      console.log('Value to Withdraw ', this.depositAmount)
      this.contractBalance = null
      this.pending = true
      this.$store.state.contractInstance().withdraw(
        this.selectedWithdraw === 'wei' ? this.withdrawAmount : this.$store.state.web3.web3Instance().toWei(this.withdrawAmount, 'ether'),
        {
          gas: 300000,
          from: this.$store.state.web3.coinbase
        },
        (err, result) => {
          if (err) {
            console.log(err)
            this.pending = false
          } else {
            console.log('SIN ERRORES')
          }
        }
      )
    }
  },
  mounted () {
    console.log('dispatching getContractInstance')
    this.$store.dispatch('getContractInstance')
  }
}
</script>
<style scoped>
#savings-dapp {
  font-family: "Lucida Console", "Courier New", monospace;
  border-collapse: collapse;
  width: 100%;
}
#savings-dapp td,
#savings-dapp th {
  border: 1px solid #ddd;
  padding: 2px;
  text-align: center;
}
#savings-dapp tr:nth-child(even) {
  background-color: #f2f2f2;
}
#savings-dapp th {
  padding-top: 2px;
  padding-bottom: 2px;
  text-align: center;
  color: white;
}
.button {
  display: inline-block;
  padding: 15px 25px;
  font-size: 12px;
  cursor: pointer;
  text-align: center;
  text-decoration: none;
  outline: none;
  color: #fff;
  background-color: #008CBA;
  border: none;
  border-radius: 15px;
}
.button:hover {background-color: #233387}
</style>
